package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAsset;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAsset] 服务对象接口
 */
public interface IEAMAssetService extends IService<EAMAsset>{

    boolean create(EAMAsset et) ;
    void createBatch(List<EAMAsset> list) ;
    boolean update(EAMAsset et) ;
    void updateBatch(List<EAMAsset> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAsset get(String key) ;
    EAMAsset getDraft(EAMAsset et) ;
    boolean checkKey(EAMAsset et) ;
    boolean save(EAMAsset et) ;
    void saveBatch(List<EAMAsset> list) ;
    Page<EAMAsset> searchDefault(EAMAssetSearchContext context) ;
    List<EAMAsset> selectByEamassettypeid(String eamassettypeid) ;
    void removeByEamassettypeid(String eamassettypeid) ;
    List<EAMAsset> selectByPassetid(String assetid) ;
    void removeByPassetid(String assetid) ;
    List<EAMAsset> selectByEamlocationid(String eamlocationid) ;
    void removeByEamlocationid(String eamlocationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAsset> getEamassetByIds(List<String> ids) ;
    List<EAMAsset> getEamassetByEntities(List<EAMAsset> entities) ;
}


